/* Copyright (C) 2007 (Grandzebu)
Ce programme est libre, vous pouvez le redistribuer et/ou le
modifier selon les termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation
(version 2 ou bien toute autre version ultrieure choisie par vous).
Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, ni explicite ni implicite,
y compris les garanties de commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la Licence
Publique Gnrale GNU pour plus de dtails.

This program is free, you can redistribute it and/or
modify it under the terms of the GNU General Public License as published by the Free Software Foundation
either version 2 of the License, or (at your option) any later version.
This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

V. 1.1.0
*/

#include <windows.h>
#include "res.h"
#include <stdio.h>
#include <ws2tcpip.h>  //Contient winsock2.h - Librairie ws2_32 dans les options du linker / Embed winsock2.h - ws2_32 librairy in linker options
#include <time.h>
#include <string>

#define WM_SYSTRAY (WM_USER +1)
#define WM_WSAASYNC (WM_USER +2)
#define MAX_LEN_IP_ADDRESS 15
NOTIFYICONDATA MyIconData;
HINSTANCE ModInstance;
int WM_TaskbarCreated;
HWND MyWindow;
bool SockFlagContinue;
bool SockFlagError;
char SockBuffer[1024];
int SockBufferLen;
char* PortHTTP = "80";
char Login[32];
char Password[16];
char UpdateHostName[32];
char DynHostName[32];
char EchoIPHostName[32];
char EchoIPScript[32];
char StatutOK[32];
char StatutKO[32];
char UpdateOK[32];
char UpdateKO[32];
char QuitMenu[2];
char MyIP[MAX_LEN_IP_ADDRESS + 1];
char StatutIP[256];
char StatutDNS[128];

char* IntToString(DWORD i, char *MyString) {
  //V 1.0
  // Paramtres :
  //    - Un nombre entier
  //    - Pointeur sur une chaine
  // Retour : Pointeur sur la chaine passe en paramtre et qui contient le nombre
  // Parameters :
  //    - An integer number
  //    - Pointer on a string of size _MAX_PATH
  // Return : Pointer on the string passed in parameter and which contain the number
  sprintf(MyString, "%d", i);
  return &MyString[0];
}

bool IsIP(char *MyString) {
  // V 1.0
  // Paramtres :
  //    - Pointeur sur une chaine
  // Retour : Vrai si la chaine contient une adresse IP valide, sinon Faux
  // Parameters :
  //    - Pointer on a string
  // Return : True if the string contain a valid IP address, else False
  char Buffer[4];
  int Posit = 0;
  int NbOctet = 0;
  int i;
  for (i = 0; i <= strlen(MyString); i++) {
    if (MyString[i] == '.' || i == strlen(MyString)) {
      if (Posit == 0) return false;   //Pas de chiffre avant le point / No digit before the dot
      Buffer[Posit] = 0;
      if (atoi(Buffer) > 255) return false;   // Valeur > 255 / Value > 255
      Posit = 0;
      NbOctet++;
    } else {
      if (Posit == 3) return false;   // Pas de point aprs 3 chiffres / Not a dot after 4 digits
      if (MyString[i] < '0' || MyString[i] > '9') return false;   //Car. interdit / Char. forbiden
      //Chiffre / Digit
      Buffer[Posit] = MyString[i];
      Posit++;
    }
  }
  if (NbOctet != 4) return false;   //On n'a pas 4 octets / We don't have 4 bytes
  return true;
}

char* FrDate(char *MyString) {
  // V 1.0
  // Paramtres :
  //    - Pointeur sur une chaine d'au moins 9 caractres
  // Retour : Pointeur sur la chaine passe en paramtre et qui contient la date courante formate selon JJ/MM/AA
  // Parameters :
  //    - Pointer on a string of at least 9 characters
  // Return : Pointer on the string passed in parameter and which contain the current date formated according DD/MM/YY
  char Buffer[9];
  _strdate(Buffer);
  MyString[0] = Buffer[3];
  MyString[1] = Buffer[4];
  MyString[2] = '/';
  MyString[3] = Buffer[0];
  MyString[4] = Buffer[1];
  MyString[5] = '/';
  MyString[6] = Buffer[6];
  MyString[7] = Buffer[7];
  MyString[8] = 0;
  return &MyString[0];
}

void ErrorBox(int IdString) {
  char Chaine[64];
  LoadString(ModInstance, IdString, Chaine, 64);
  MessageBox(NULL, Chaine, "", MB_OK);
}

void SocketError(int ErrValue) {
  char Chaine1[64];
  char Chaine2[64];
  LoadString(ModInstance, ID_STRING_ERR_5, Chaine1, 64);
  strcat(Chaine1, IntToString(ErrValue, Chaine2));
  MessageBox(NULL, Chaine1, "Erreur", MB_OK);
}

float Power(float Base, float Expo) {
    // V 1.0
    // Paramtres : 2 nombres (e peut tre ngatif)
    // Retour : la valeur de Base puissance Expo
    // Rarameters : 2 numbers (e can be negative)
    // Return : Value of Base raised to Expo power
  float Accu = 1;
  if (Expo == 0) return Accu;
  if (Expo > 0) {
    while (Expo != 0) {
      Accu = Accu * Base;
      Expo--;
    }
  } else {
    while (Expo != 0) {
      Accu = Accu / Base;
      Expo++;
    }
  }
  return Accu;
}

char* Encode64(char* MyString, int MyStringSize) {
  // V 1.1
  // Paramtres :
  //    - Pointeur sur une chaine  encoder
  //    - Taille de la variable chaine - Il FAUT respecter la condition : MyStringSize >= (strlen(MyString) + 3) * 4 / 3
  // Retour : Pointeur sur la chaine passe en paramtre et qui est maintenant encode en base64 et formate tel que dfinit dans la RFC2045 http://jlr31130.free.fr/rfc2045.html
  // Ncessite : Power
  // Parameters :
  //    - Pointer on a string to encode
  //    - Size of the string variable - Condition SHOULD be observed : MyStringSize >= (strlen(MyString) + 3) * 4 / 3
  // Return : Pointer on the string passed in parameter and which is now encoded in base64 and is formatted such as defines in the RFC2045 http://www.faqs.org/rfcs/rfc2045.html
  // Need : Power
  int Pointeur;
  int Pointeur2;
  int CompteurBit;
  int Accumulateur;
  unsigned char Tempo;
  char CharSet[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  if (MyStringSize >= (strlen(MyString) + 3) * 4 / 3) {
    CompteurBit = MyStringSize - strlen(MyString);
    // Dplacer la chaine  droite  / Move the string to right
    for (Pointeur = strlen(MyString) - 1; Pointeur >= 0; Pointeur--) {
      MyString[Pointeur + CompteurBit] = MyString[Pointeur];
    }
    Pointeur = CompteurBit;
    Pointeur2 = 0;
    CompteurBit = 0;
    Accumulateur = 0;
    while (Pointeur < MyStringSize) {
      // Traite un caractre de la chaine
      // Dcaler ce qui reste dans l'accumulateur de 8 bits  gauche et ajouter un nouveau caractre
      Accumulateur = Accumulateur * 256 + (Tempo = MyString[Pointeur]);   // Tempo vite que les car. > 127 soient ngatifs / Tempo prevents that char. > 127 are negative
      CompteurBit = CompteurBit + 8;
      while (CompteurBit >= 6 || (Pointeur == MyStringSize - 1 && CompteurBit > 0)) {
        // Ajouter un caractre (correspondant aux 6 bits de gauche de l'accumulateur)  la chaine produite
        CompteurBit = CompteurBit - 6;
        MyString[Pointeur2] = CharSet[(int) (Accumulateur / Power(2, CompteurBit))];
        Pointeur2++;
        // Retirer les 6 premiers bits de l'accumulateur
        Accumulateur = Accumulateur & (int) (Power(2, CompteurBit) - 1);
      }
      Pointeur = Pointeur + 1;
    }
    // Ajouter 1 ou 2 caractres de fin si le nombre de caractres  encoder n'est pas multiple de 3
    while (Pointeur2 % 4 > 0) {
      MyString[Pointeur2] = '=';
      Pointeur2++;
    }
    MyString[Pointeur2] = 0;
  } else {
    MyString[0] = 0;
  }
  return &MyString[0];
}

void DoEvents() {
  // V 1.0
  // Redonne la main au systme pour traiter les messages
  // Give again the hand to the system to treat the messages
  MSG msg;
  while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
}

void GetINI() {
  GetPrivateProfileString( "PARAMETRES", "Login", "", Login, 32, ".\\DynDNSupdate.ini");
  GetPrivateProfileString( "PARAMETRES", "Password", "", Password, 16, ".\\DynDNSupdate.ini");
  GetPrivateProfileString( "PARAMETRES", "UpdateHostName", "", UpdateHostName, 32, ".\\DynDNSupdate.ini");
  GetPrivateProfileString( "PARAMETRES", "DynHostName", "", DynHostName, 32, ".\\DynDNSupdate.ini");
  GetPrivateProfileString( "PARAMETRES", "EchoIPHostName", "", EchoIPHostName, 32, ".\\DynDNSupdate.ini");
  GetPrivateProfileString( "PARAMETRES", "EchoIPScript", "", EchoIPScript, 32, ".\\DynDNSupdate.ini");
  GetPrivateProfileString( "PARAMETRES", "QuitMenu", "", QuitMenu, 2, ".\\DynDNSupdate.ini");
  LoadString(ModInstance, STATUT_OK, StatutOK, 32);
  LoadString(ModInstance, STATUT_KO, StatutKO, 32);
  LoadString(ModInstance, UPDATE_OK, UpdateOK, 32);
  LoadString(ModInstance, UPDATE_KO, UpdateKO, 32);
}

void AddTaskbarIcons(HWND WinHandle) {
  // Installation de l'icone dans le systray / Install icon in the systray
  MyIconData.cbSize = sizeof(NOTIFYICONDATA);
  MyIconData.hWnd = WinHandle;
  MyIconData.uID = 0;
  MyIconData.hIcon = LoadIcon(ModInstance, MAKEINTRESOURCE(ID_ICONE_1));
  MyIconData.uCallbackMessage = WM_USER + 1;
  MyIconData.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
  strcpy(MyIconData.szTip, "dynDNSupdate");
  Shell_NotifyIcon(NIM_ADD, &MyIconData);
}

bool SendNet(SOCKET MySocket, char *MyDatas, addrinfo *SocketAddr, int Tempo) {
  //Connection du socket si MyDatas est vide, sinon envoi de la requte
  //Connect the socket if MyDatas is empty, else send the request.
  //Paramtres en entre / Input parameters
  //   MySocket : Le socket / The socket
  //   MyDatas : Pointeur sur le texte de la requte / Pointer to the request text
  //   SocketAddr : Pointeur vers la structure addrinfo, requis si MyDatas est vide / Pointer to the addrinfo struct, requested if MyDatas is empty
  //   Tempo : Time-out en secondes / Time-out in seconds
  //Retourne / return
  //   false : erreur ou dpassement de time-out / Error or over time-out
  //   true : OK
  bool SendNetState;
  double Chrono;
  SendNetState = true;
  SockFlagContinue = false;
  if (strlen(MyDatas) > 0) {
    SockBufferLen = 0;
    SockBuffer[0] = 0;
    send(MySocket, MyDatas, strlen(MyDatas), 0);
  } else {
    connect(MySocket, SocketAddr->ai_addr, (int)SocketAddr->ai_addrlen);
  }
  Chrono = clock() + Tempo * CLOCKS_PER_SEC;
  while (! SockFlagContinue) {
    DoEvents();
    if (clock() > Chrono || SockFlagError) {
      //Erreur ou dpassement de dure / Error or time-out
      SockFlagError = true;
      SendNetState = false;
      break;
    }
  }
  return SendNetState;
}

int TestIP(char* NewIP) {
  int i;
  int Posit;
  int ReturnValue = 0;
  SOCKET MySocket;
  struct addrinfo MyAddr;
  struct addrinfo *AddrHost = NULL;
  SockFlagError = false;
  SockFlagContinue = false;
  char SendBuffer[1024];
  NewIP[0] = 0;
  SendBuffer[0] = 0;
  memset(&MyAddr, 0, sizeof(MyAddr));
  MyAddr.ai_socktype = SOCK_STREAM;
  MyAddr.ai_family = AF_INET;
  MyAddr.ai_protocol = IPPROTO_TCP;
  if (getaddrinfo(EchoIPHostName, PortHTTP, &MyAddr, &AddrHost) == 0) {
    if (AddrHost != NULL) {
      if ((MySocket = socket(AddrHost->ai_family, AddrHost->ai_socktype, AddrHost->ai_protocol)) != INVALID_SOCKET) {
        WSAAsyncSelect(MySocket, MyWindow, WM_WSAASYNC, FD_CONNECT | FD_READ | FD_CLOSE);
        if (SendNet(MySocket, SendBuffer, AddrHost, 5)) {
          //Maintenant le socket est connect / Now socket is connected
          sprintf(SendBuffer, "GET /%s HTTP/1.0\r\nHost: %s\r\n\r\n", EchoIPScript, EchoIPHostName);
          if (SendNet(MySocket, SendBuffer, 0, 10)) {   //Envoie de la requte / Send of the request
            if (strstr(SockBuffer, "\r\n\r\n")) {
              if ((int) strstr(SockBuffer, "\r\n\r\n") - (int) &SockBuffer > 6) {
                // Vrifier qu'on a bien une adresse ip valide / Check if we get a valid ip address
                strncpy(NewIP, strstr(SockBuffer, "\r\n\r\n") + 4, MAX_LEN_IP_ADDRESS);   //SendBuffer est utilise comme tampon temporaire / SendBuffer is used as a temporary buffer
                if (IsIP(NewIP)) {
                  shutdown(MySocket, 2);
                  return true;
                }
              }
            }
          }
        }
      }
    }
  }
  shutdown(MySocket, 2);
  return false;
}

bool UpdateDyn() {
  int ReturnValue = 0;
  SOCKET MySocket;
  struct addrinfo MyAddr;
  struct addrinfo *AddrHost = NULL;
  SockFlagError = false;
  SockFlagContinue = false;
  char SendBuffer[1024];
  char Tempo[64];
  SendBuffer[0] = 0;
  Tempo[0] = 0;
  memset(&MyAddr, 0, sizeof(MyAddr));
  MyAddr.ai_socktype = SOCK_STREAM;
  MyAddr.ai_family = AF_INET;
  MyAddr.ai_protocol = IPPROTO_TCP;
  if (getaddrinfo(UpdateHostName, PortHTTP, &MyAddr, &AddrHost) == 0) {
    if (AddrHost != NULL) {
      if ((MySocket = socket(AddrHost->ai_family, AddrHost->ai_socktype, AddrHost->ai_protocol)) != INVALID_SOCKET) {
        WSAAsyncSelect(MySocket, MyWindow, WM_WSAASYNC, FD_CONNECT | FD_READ | FD_CLOSE);
        if (SendNet(MySocket, SendBuffer, AddrHost, 5)) {
          //Maintenant le socket est connect / Now socket is connected
          strcpy(Tempo, Login);
          strcat(Tempo, ":");
          strcat(Tempo, Password);
          sprintf(SendBuffer, "GET /nic/update?system=dyndns&hostname=%s&myip=%s HTTP/1.0\r\nHost: %s\r\nUser-Agent: DynDNSupdate by grandzebu.net\r\nAuthorization: Basic %s\r\n\r\n", DynHostName, MyIP, UpdateHostName, Encode64(Tempo, sizeof(Tempo)));
          if (SendNet(MySocket, SendBuffer, 0, 10)) {   //Envoie de la requte / Send of the request
            if (strstr(SockBuffer,"\r\n\r\n")) {
              if (strstr(SockBuffer, MyIP)) {
                shutdown(MySocket, 2);
                return true;
              }
            }
          }
        }
      }
    }
  }
  shutdown(MySocket, 2);
  return false;
}

LRESULT CALLBACK WindowProcedure(HWND WinHandle, UINT WinMessage, WPARAM Param1, LPARAM Param2) {
  HMENU hmenu;
  HMENU hpopup;
  POINT pos;
  int ReturnValue;
  char NewIP[MAX_LEN_IP_ADDRESS + 1];
  switch (WinMessage) {
  case WM_CREATE:
    // Ecouter le message reu en cas de crash d'explorer / Listen message received  in case of an explorer crash
    WM_TaskbarCreated = RegisterWindowMessage("TaskbarCreated");
    AddTaskbarIcons(WinHandle);
    break;
  case WM_SYSTRAY:   //Messages reus de l'icone dans le systray / Messages received from the systray icon.
    //Type de message dans Param2 / Message type in Param2
    switch(Param2) {
    case WM_RBUTTONUP:
      if (strcmp(QuitMenu, "0") == 1) {
        GetCursorPos(&pos);
        hmenu = LoadMenu(ModInstance, "IDR_MENU");
        hpopup = GetSubMenu(hmenu, 0);
        TrackPopupMenuEx(hpopup, 0, pos.x, pos.y, WinHandle, NULL);
        DestroyMenu(hmenu);
      }
      break;
    }
    break;
  case WM_COMMAND:
    if(LOWORD(Param1) == ID_MENU_QUITTER) DestroyWindow(WinHandle);
    break;
  case WM_TIMER:
    NewIP[0] = 0;
    strcpy(StatutIP, StatutKO);
    if (TestIP(NewIP)) {
      //Adresse modifie / address modified
      strcpy(StatutIP, StatutOK);
      strcat(StatutIP, " ");
      strcat(StatutIP, NewIP);
      if (strcmp(NewIP, MyIP) != 0 || strcmp(StatutDNS, UpdateKO) == 0) {
        strcpy(MyIP, NewIP);
        if (UpdateDyn()) {
          //Mise  jour OK / Update OK
          strcpy(StatutDNS, UpdateOK);
          strcat(StatutDNS, " ");
          FrDate(NewIP);
          strcat(StatutDNS, NewIP);
          strcat(StatutDNS, " ");
          _strtime(NewIP);
          strcat(StatutDNS, NewIP);
        }
      }
    }
    strcat(StatutIP, "\r\n");
    strcat(StatutIP, StatutDNS);
    strcpy(MyIconData.szTip, StatutIP);
    Shell_NotifyIcon(NIM_MODIFY, &MyIconData);
    break;
  case WM_WSAASYNC:
    //La fonction SendNet attend ces venements // SendNet function wait for theses events
    switch(WSAGETSELECTEVENT(Param2)) {
    case FD_READ:
      // Ajouter les octets reus au tampon / Add received bytes to the buffer
      SockBufferLen = SockBufferLen + recv(Param1, &SockBuffer[strlen(SockBuffer)], sizeof(SockBuffer) - strlen(SockBuffer), 0);
      break;
    case FD_CONNECT:
      SockFlagContinue = true;
      break;
    case FD_CLOSE:
      // La rponse est dans le tampon / Response is in the buffer
      SockBuffer[SockBufferLen] = 0;
      SockFlagContinue = true;
      break;
    }
    break;
  case WM_DESTROY:
    Shell_NotifyIcon(NIM_DELETE,&MyIconData);
    PostQuitMessage(0);
    return 0;
  default:
    if (WinMessage == WM_TaskbarCreated) {
      AddTaskbarIcons(WinHandle);
      break;
    }
    return DefWindowProc(WinHandle, WinMessage, Param1, Param2);
  }
  return 0;
}

int WINAPI WinMain(HINSTANCE Instance, HINSTANCE PrevInstance, LPSTR CmdLine, int CmdShow) {
  MSG MyMessage;
  WNDCLASSEX MyClass;
  char ClassName[] = "dynDNS_Class";
  HANDLE MyMutex;
  int MyTimer;
  int ReturnValue = 0;
  WSADATA MyWSAData;
  ModInstance = Instance;
  MyMutex = CreateMutex(NULL, 1, ClassName);
  if (MyMutex) {
    if (GetLastError() != ERROR_ALREADY_EXISTS) {
      MyClass.cbSize = sizeof(WNDCLASSEX);
      MyClass.style = 0;
      MyClass.lpfnWndProc = WindowProcedure;
      MyClass.cbClsExtra = 0;
      MyClass.cbWndExtra = 0;
      MyClass.hInstance = ModInstance;
      MyClass.hIcon = NULL; //Pas de fentre visible / Not visible window
      MyClass.hCursor = NULL;
      MyClass.hbrBackground = NULL;
      MyClass.lpszMenuName =  NULL;
      MyClass.lpszClassName = ClassName;
      MyClass.hIconSm = NULL;
      MyWindow = CreateWindowEx(WS_EX_APPWINDOW, (LPCTSTR)RegisterClassEx(&MyClass), NULL, 0, 0, 0, 0, 0, NULL, NULL, ModInstance, NULL);
      if (MyWindow) {
        GetINI();
        MyIP[0] = 0;
        strcpy(StatutDNS, UpdateKO);
        MyTimer = SetTimer(MyWindow, 0, 60000, (TIMERPROC) NULL);
        if (MyTimer) {
          if ((ReturnValue = WSAStartup(MAKEWORD(2,0), &MyWSAData)) == 0) {
            while (GetMessage(&MyMessage, NULL, 0, 0)) {
              TranslateMessage(&MyMessage);
              DispatchMessage(&MyMessage);
            }
            ReturnValue = MyMessage.wParam;
          } else {
            //Erreur avec WSAstartup / Error with WSAstartup
            SocketError(ReturnValue);
          }
        } else {
          //Ne peux pas crer de timer / Can't create a timer
          ErrorBox(ID_STRING_ERR_4);
          ReturnValue = ID_STRING_ERR_4;
        }
      } else {
        //Ne peux pas crer la fentre / Can't create the window
        ErrorBox(ID_STRING_ERR_1);
        ReturnValue = ID_STRING_ERR_1;
      }
    } else {
      //Le mutex existe dj / The mutex already exist
      ErrorBox(ID_STRING_ERR_2);
      ReturnValue = ID_STRING_ERR_2;
    }
  } else {
    //Ne peux pas crer le mutex / Can't create the mutex
    ErrorBox(ID_STRING_ERR_3);
    ReturnValue = ID_STRING_ERR_3;
  }
  WSACleanup();
  ReleaseMutex(MyMutex);
  return ReturnValue;
}
